> ## Documentation Index
> Fetch the complete documentation index at: https://docs.bebop.xyz/llms.txt
> Use this file to discover all available pages before exploring further.

# Quote

> ## Overview
            Get a quote for the requested tokens and amounts. This endpoint allows you to request quotes for one-to-one trades as well as multi token trades (one-to-many and many-to-one).

            ## Executing the quote
            By default this is a gasless quote and will need to be submitted to [`/order`](#/v3/post_order_v3_order_post)

            Specifying `gasless=false` to the API will return `tx` that can be used to self execute. You may also specify `skip_validation` for use cases where validations are a constraint.



## OpenAPI

````yaml /specs/rfq-api.json get /v3/quote
openapi: 3.1.0
info:
  title: Bebop RFQ API
  version: '3'
  description: >-
    Request-for-quote trading API. Get quotes and execute token swaps directly
    with market makers.
servers:
  - url: https://api.bebop.xyz/pmm/{chain}
    variables:
      chain:
        default: ethereum
        enum:
          - ethereum
          - polygon
          - arbitrum
          - optimism
          - base
          - bsc
          - blast
          - zksync
          - mode
          - scroll
          - taiko
          - superseed
          - berachain
          - hyperevm
          - avalanche
        description: Blockchain network
security: []
paths:
  /v3/quote:
    get:
      summary: Quote
      description: |-
        ## Overview
                    Get a quote for the requested tokens and amounts. This endpoint allows you to request quotes for one-to-one trades as well as multi token trades (one-to-many and many-to-one).

                    ## Executing the quote
                    By default this is a gasless quote and will need to be submitted to [`/order`](#/v3/post_order_v3_order_post)

                    Specifying `gasless=false` to the API will return `tx` that can be used to self execute. You may also specify `skip_validation` for use cases where validations are a constraint.
      operationId: getQuote
      parameters:
        - name: sell_tokens
          in: query
          required: true
          schema:
            type: string
            x-default: '0xA0b86991c6218b36c1d19D4a2e9Eb0cE3606eB48'
            example: '0xA0b86991c6218b36c1d19D4a2e9Eb0cE3606eB48'
          description: The tokens that will be supplied by the taker
        - name: buy_tokens
          in: query
          required: true
          schema:
            type: string
            x-default: '0xC02aaA39b223FE8D0A0e5C4F27eAD9083C756Cc2'
            example: '0xC02aaA39b223FE8D0A0e5C4F27eAD9083C756Cc2'
          description: The tokens that will be supplied by the maker
        - name: sell_amounts
          in: query
          required: false
          schema:
            type: string
            x-default: '1000000000'
            example: '1000000000'
          description: The amount of each taker token, order respective to taker_tokens
        - name: buy_amounts
          in: query
          required: false
          schema:
            anyOf:
              - type: string
              - type: 'null'
            title: Buy Token Amounts
            description: The amount of each maker token, order respective to maker_tokens
          description: The amount of each maker token, order respective to maker_tokens
          examples:
            None:
              description: Use when specifying 'sell_amounts'
            One:
              summary: One To One / Many To One
              description: Use for 'One To One' or 'One To Many' quotes
              value: '100000000'
            Many:
              summary: One To Many
              description: Use for 'One To Many' quotes
              value: 100000000,100000000
        - name: taker_address
          in: query
          required: true
          schema:
            type: string
            x-default: '0x5Bad996643a924De21b6b2875c85C33F3c5bBcB6'
            example: '0x5Bad996643a924De21b6b2875c85C33F3c5bBcB6'
          description: Address which will sign the order
        - name: receiver_address
          in: query
          required: false
          schema:
            anyOf:
              - type: string
              - type: 'null'
            title: Receiver Address
            description: >-
              Address which will receive the taker tokens. (Defaults to
              taker_address if not specified)
          description: >-
            Address which will receive the taker tokens. (Defaults to
            taker_address if not specified)
        - name: source
          in: query
          required: false
          schema:
            anyOf:
              - type: string
              - type: 'null'
            title: Source
            description: Referral partner that will be associated with the quote.
          description: Referral partner that will be associated with the quote.
        - name: approval_type
          in: query
          required: false
          schema:
            $ref: '#/components/schemas/ApprovalType'
            title: Type of approval
            description: 'Type of Approval for EVM: Standard/Permit/Permit2'
            default: Standard
          description: 'Type of Approval for EVM: Standard/Permit/Permit2'
        - name: buy_tokens_ratios
          in: query
          required: false
          schema:
            anyOf:
              - type: string
              - type: 'null'
            title: Buy Tokens Ratios
            description: Ratios of maker tokens to receive for each taker token
          description: Ratios of maker tokens to receive for each taker token
          examples:
            Default: {}
            One To Many:
              summary: One To Many
              description: Use ONLY with 'One To Many' quotes and specified 'sell_amounts'
              value: 0.5,0.5
        - name: sell_tokens_ratios
          in: query
          required: false
          schema:
            anyOf:
              - type: string
              - type: 'null'
            title: Sell Tokens Ratios
            description: Ratios of taker tokens to receive for each maker token
          description: Ratios of taker tokens to receive for each maker token
          examples:
            Default: {}
            Many To One:
              summary: Many To One
              description: Use ONLY with 'Many To One' quotes and specified 'buy_amounts'
              value: 0.5,0.5
        - name: gasless
          in: query
          required: false
          schema:
            type: boolean
            title: Gasless
            description: Set to false to receive call data and self execute.
            x-default: false
          description: Set to false to receive call data and self execute.
        - name: slippage
          in: query
          required: false
          schema:
            anyOf:
              - type: number
              - type: string
              - type: 'null'
            title: Slippage
            description: The slippage to use
          description: The slippage to use
        - name: origin_address
          in: query
          required: false
          schema:
            anyOf:
              - type: string
              - type: 'null'
            title: Origin Address
            description: Original user of the quote if different than taker.
          description: Original user of the quote if different than taker.
        - name: expiry_type
          in: query
          required: false
          schema:
            $ref: '#/components/schemas/ExpiryType'
            title: Type of expiry
            description: Standard, Short (5 seconds)
            default: standard
          description: Standard, Short (5 seconds)
        - name: fee
          in: query
          required: false
          schema:
            anyOf:
              - type: number
              - type: string
            title: Partner Fee
            description: Fee (bps) to be charged for this quote
            default: '0'
          description: Fee (bps) to be charged for this quote
        - name: source-auth
          in: header
          required: false
          schema:
            anyOf:
              - type: string
              - type: 'null'
            title: Source Auth
            description: Source auth token
            required: false
          description: Source auth token
      responses:
        '200':
          description: Success
          content:
            application/json:
              schema:
                $ref: '#/components/schemas/QuoteApiResponse'
              examples:
                EVM:
                  summary: EVM (Ethereum, Polygon, etc.)
                  value:
                    requestId: 31a8cd0e-4566-48ad-8fe0-92efcde63dc2
                    type: '121'
                    status: SIG_SUCCESS
                    quoteId: 121-197055704233248307894658608409132099557
                    chainId: 1
                    approvalType: Standard
                    nativeToken: ETH
                    taker: '0x5Bad996643a924De21b6b2875c85C33F3c5bBcB6'
                    receiver: '0x5Bad996643a924De21b6b2875c85C33F3c5bBcB6'
                    expiry: 1772813487
                    slippage: 0
                    gasFee:
                      native: '0'
                      usd: 0
                    buyTokens:
                      '0xC02aaA39b223FE8D0A0e5C4F27eAD9083C756Cc2':
                        amount: '504765657558485082'
                        decimals: 18
                        priceUsd: 1980.81
                        symbol: WETH
                        minimumAmount: '504765657558485082'
                        price: 1981.1173462888255
                        priceBeforeFee: 1971.2599999999998
                        amountBeforeFee: '507289753761553600'
                        deltaFromExpected: -0.00010614305258680328
                    sellTokens:
                      '0xA0b86991c6218b36c1d19D4a2e9Eb0cE3606eB48':
                        amount: '1000000000'
                        decimals: 6
                        priceUsd: 0.999951
                        symbol: USDC
                        price: 0.0005047656575584851
                        priceBeforeFee: 0.0005072897537615536
                    settlementAddress: '0xbbbbbBB520d69a9775E85b458C58c648259FAD5F'
                    approvalTarget: '0xbbbbbBB520d69a9775E85b458C58c648259FAD5F'
                    requiredSignatures: []
                    priceImpact: -0.00010614305258680328
                    partnerFee:
                      '0xEeeeeEeeeEeEeeEeEeEeeEEEeeeeEeeeeeeeEEeE': '2524096203068442'
                    warnings: []
                    tx:
                      to: '0xbbbbbBB520d69a9775E85b458C58c648259FAD5F'
                      value: '0x0'
                      data: 0x4dcebcba00...
                      from: '0x5Bad996643a924De21b6b2875c85C33F3c5bBcB6'
                      gas: 102504
                      gasPrice: 459274878
                    makers:
                      - 🦖2
                    toSign:
                      partner_id: 0
                      expiry: 1772813487
                      taker_address: '0x5Bad996643a924De21b6b2875c85C33F3c5bBcB6'
                      maker_address: '0xA8020EcBC321e0C8cEA26B3507f207482d0100c2'
                      maker_nonce: '2772802508865834001'
                      taker_token: '0xA0b86991c6218b36c1d19D4a2e9Eb0cE3606eB48'
                      maker_token: '0xC02aaA39b223FE8D0A0e5C4F27eAD9083C756Cc2'
                      taker_amount: '1000000000'
                      maker_amount: '504765657558485082'
                      receiver: '0x5Bad996643a924De21b6b2875c85C33F3c5bBcB6'
                      packed_commands: '0'
                    onchainOrderType: SingleOrder
                    partialFillOffset: 12
                Solana:
                  summary: Solana
                  value:
                    requestId: e3a9ea52-422a-4670-8136-78edd249e112
                    type: '121'
                    status: QUOTE_INDIC_ROUTE
                    quoteId: 121-244365056209752849084454405377701099760
                    chainId: 2
                    approvalType: Standard
                    nativeToken: SOL
                    taker: 6ZRCB7AAqGre6c72PRz3MHLC73VMYvJ8bi9KHf1HFpNk
                    receiver: 6ZRCB7AAqGre6c72PRz3MHLC73VMYvJ8bi9KHf1HFpNk
                    expiry: 1772813478
                    slippage: 0
                    gasFee:
                      native: '0'
                      usd: 0
                    buyTokens:
                      So11111111111111111111111111111111111111112:
                        amount: '11721973075'
                        decimals: 9
                        priceUsd: 84.7
                        symbol: WSOL
                        minimumAmount: '11721973075'
                        price: 85.30987007065788
                        priceBeforeFee: 85.30987007065788
                        amountBeforeFee: '11721973075'
                        deltaFromExpected: -0.007100228458694477
                    sellTokens:
                      EPjFWdd5AufqSSqeM2qN1xzybapC8G4wEGGkZwyTDt1v:
                        amount: '1000000000'
                        decimals: 6
                        priceUsd: 0.999951
                        symbol: USDC
                        price: 0.011721973075
                        priceBeforeFee: 0.011721973075
                    settlementAddress: BEboPej97QDH5PS9xzCVxM5vvorvwENjtt3PV5n8b62
                    approvalTarget: ''
                    requiredSignatures: []
                    priceImpact: -0.007100228458694477
                    warnings: []
                    solana_tx: AgAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAA...
                    blockhash: 4dori8DoX1gEzFdrFjRnKd37EmL6Akh75VfHzkxo1NNL
                    makers:
                      - 🦊
        '422':
          description: Validation Error
          content:
            application/json:
              schema:
                $ref: '#/components/schemas/HTTPValidationError'
components:
  schemas:
    ApprovalType:
      type: string
      enum:
        - Standard
        - Permit
        - Permit2
      title: ApprovalType
    ExpiryType:
      type: string
      enum:
        - standard
        - short
      title: ExpiryType
    QuoteApiResponse:
      properties:
        requestId:
          type: string
          title: Requestid
        type:
          type: string
          title: Type
        status:
          type: string
          title: Status
        quoteId:
          type: string
          title: Quoteid
        chainId:
          type: integer
          title: Chainid
        approvalType:
          $ref: '#/components/schemas/ApprovalType'
        nativeToken:
          type: string
          title: Nativetoken
        taker:
          type: string
          title: Taker
        receiver:
          type: string
          title: Receiver
        expiry:
          type: integer
          title: Expiry
        slippage:
          type: number
          title: Slippage
        gasFee:
          $ref: '#/components/schemas/GasFeeResponse'
        buyTokens:
          additionalProperties:
            $ref: '#/components/schemas/ResponseBuyToken'
          type: object
          title: Buytokens
        sellTokens:
          additionalProperties:
            $ref: '#/components/schemas/ResponseSellToken'
          type: object
          title: Selltokens
        settlementAddress:
          type: string
          title: Settlementaddress
        approvalTarget:
          type: string
          title: Approvaltarget
        requiredSignatures:
          items:
            type: string
          type: array
          title: Requiredsignatures
        priceImpact:
          anyOf:
            - type: number
            - type: 'null'
          title: Priceimpact
        partnerFee:
          anyOf:
            - additionalProperties:
                type: string
              type: object
            - type: 'null'
          title: Partnerfee
        protocolFee:
          anyOf:
            - additionalProperties:
                type: string
              type: object
            - type: 'null'
          title: Protocolfee
        warnings:
          items:
            $ref: '#/components/schemas/PriceWarning'
          type: array
          title: Warnings
          default: []
        info:
          anyOf:
            - type: string
            - type: 'null'
          title: Info
        tx:
          anyOf:
            - $ref: '#/components/schemas/TxData'
            - type: 'null'
        solana_tx:
          anyOf:
            - type: string
            - type: 'null'
          title: Solana Tx
        blockhash:
          anyOf:
            - type: string
            - type: 'null'
          title: Blockhash
        makers:
          items:
            type: string
          type: array
          title: Makers
        toSign:
          anyOf:
            - $ref: '#/components/schemas/SingleOrderToSign'
            - type: 'null'
          title: Tosign
        onchainOrderType:
          anyOf:
            - type: string
            - type: 'null'
          title: Onchainordertype
        partialFillOffset:
          anyOf:
            - type: integer
            - type: 'null'
          title: Partialfilloffset
        guaranteeBoost:
          anyOf:
            - type: string
            - type: 'null'
          title: Guaranteeboost
      type: object
      required:
        - requestId
        - type
        - status
        - quoteId
        - chainId
        - approvalType
        - nativeToken
        - taker
        - receiver
        - expiry
        - slippage
        - gasFee
        - buyTokens
        - sellTokens
        - settlementAddress
        - approvalTarget
        - requiredSignatures
        - makers
        - toSign
        - onchainOrderType
      title: QuoteApiResponse
    HTTPValidationError:
      properties:
        detail:
          items:
            $ref: '#/components/schemas/ValidationError'
          type: array
          title: Detail
      type: object
      title: HTTPValidationError
    GasFeeResponse:
      properties:
        native:
          type: string
          title: Native
        usd:
          anyOf:
            - type: number
            - type: 'null'
          title: Usd
      type: object
      required:
        - native
      title: GasFeeResponse
    ResponseBuyToken:
      properties:
        amount:
          type: string
          title: Amount
        decimals:
          type: integer
          title: Decimals
        priceUsd:
          anyOf:
            - type: number
            - type: 'null'
          title: Priceusd
        symbol:
          type: string
          title: Symbol
        minimumAmount:
          type: string
          title: Minimumamount
        price:
          anyOf:
            - type: number
            - type: 'null'
          title: Price
        priceBeforeFee:
          anyOf:
            - type: number
            - type: 'null'
          title: Pricebeforefee
        amountBeforeFee:
          anyOf:
            - type: string
            - type: 'null'
          title: Amountbeforefee
        deltaFromExpected:
          anyOf:
            - type: number
            - type: 'null'
          title: Deltafromexpected
      type: object
      required:
        - amount
        - decimals
        - symbol
        - minimumAmount
      title: ResponseBuyToken
    ResponseSellToken:
      properties:
        amount:
          type: string
          title: Amount
        decimals:
          type: integer
          title: Decimals
        priceUsd:
          anyOf:
            - type: number
            - type: 'null'
          title: Priceusd
        symbol:
          type: string
          title: Symbol
        price:
          anyOf:
            - type: number
            - type: 'null'
          title: Price
        priceBeforeFee:
          anyOf:
            - type: number
            - type: 'null'
          title: Pricebeforefee
      type: object
      required:
        - amount
        - decimals
        - symbol
      title: ResponseSellToken
    PriceWarning:
      properties:
        code:
          type: integer
          title: Code
        message:
          type: string
          title: Message
      type: object
      required:
        - code
        - message
      title: PriceWarning
    TxData:
      properties:
        chainId:
          type: integer
          title: Chainid
        from:
          anyOf:
            - type: string
            - type: 'null'
          title: From
        to:
          type: string
          title: To
        value:
          type: string
          title: Value
        data:
          type: string
          title: Data
        gas:
          anyOf:
            - type: integer
            - type: 'null'
          title: Gas
        gasPrice:
          anyOf:
            - type: integer
            - type: 'null'
          title: Gasprice
      type: object
      title: TxData
    SingleOrderToSign:
      properties:
        partner_id:
          type: integer
          title: Partner Id
        expiry:
          type: integer
          title: Expiry
        taker_address:
          type: string
          title: Taker Address
        maker_address:
          type: string
          title: Maker Address
        maker_nonce:
          type: string
          title: Maker Nonce
        taker_token:
          type: string
          title: Taker Token
        maker_token:
          type: string
          title: Maker Token
        taker_amount:
          type: string
          title: Taker Amount
        maker_amount:
          type: string
          title: Maker Amount
        receiver:
          type: string
          title: Receiver
        packed_commands:
          type: string
          title: Packed Commands
      type: object
      required:
        - partner_id
        - expiry
        - taker_address
        - maker_address
        - maker_nonce
        - taker_token
        - maker_token
        - taker_amount
        - maker_amount
        - receiver
        - packed_commands
      title: SingleOrderToSign
    ValidationError:
      properties:
        loc:
          items:
            anyOf:
              - type: string
              - type: integer
          type: array
          title: Location
        msg:
          type: string
          title: Message
        type:
          type: string
          title: Error Type
      type: object
      required:
        - loc
        - msg
        - type
      title: ValidationError

````